/**
 * url
 * method
 * data
 * header
 * dataType
 * dataType
 * responseType
 * success
 * fail
 * complete
 */

const request = parames => {
	// const config = process.env.ENV_PATH ? require('../'+process.env.ENV_PATH) : require('../env/dev.js')
	// console.log('已经入request方法',config);
	if(!parames) {
		console.warn('请求参数为空，请检查！');
		return
	}
	if(!parames.url){
		console.warn('请求url参数为空，请检查！');
		return
	}
	const port = process.env.ENV_PATH ? require('../'+process.env.ENV_PATH) : require('../env/dev.js');
	let reqData = {
		header:{}
	};
	reqData.url = port.serverPath + parames.url;
	reqData.method = parames.method ? parames.method : 'GET';
	if(parames.data){
		reqData.data = parames.data;
	}
	if(parames.header){
		reqData.header = parames.header
	}
	if(parames.dataType){
		reqData.dataType = parames.dataType
	}
	if(parames.responseType){
		reqData.responseType = parames.responseType;
	}
	
	const token = uni.getStorageSync('token');
	if(token && !parames.noToken){
		reqData.header['Authorization'] = 'Bearer ' + token
	}
	reqData.header['clientid'] = port.clientid
	
	reqData.success = res =>{
		let data = res.data
		if(data.code == 200){
			if(parames.success){
				parames.success(data)
			}
		}else{
			if(data.code == 401){
				uni.showToast({
					title: '登录过期！',
					icon:'none',
					duration: 2000
				});
				uni.removeStorageSync('token');
				uni.reLaunch({
					url: '/pages/login/login'
				});
			}else{
				if(parames.fail){
					parames.fail(data)
				}
			}
		}
		if(parames.other){
			parames.other(data)
		}
	}
	reqData.fail = err =>{
		if(parames.fail){
			parames.fail(err)
		}
	}
	reqData.complete = () => {
		if(parames.complete){
			parames.complete()
		}
	}
	uni.request(reqData)
}

export default request;